diff --git a/include/odp/api/buffer.h b/include/odp/api/buffer.h
index 9ad08ea..aea273f 100644
--- a/include/odp/api/buffer.h
+++ b/include/odp/api/buffer.h
@@ -24,7 +24,6 @@ extern "C" {
  *  @{
  */
 
-
 /**
  * @typedef odp_buffer_t
  * ODP buffer
@@ -36,16 +35,6 @@ extern "C" {
  */
 
 /**
- * @typedef odp_buffer_seg_t
- * ODP buffer segment
- */
-
-/**
- * @def ODP_SEGMENT_INVALID
- * Invalid segment
- */
-
-/**
  * Get buffer handle from event
  *
  * Converts an ODP_EVENT_BUFFER type event to a buffer.
diff --git a/include/odp/api/config.h b/include/odp/api/config.h
index 91ea34e..b5c8fdd 100644
--- a/include/odp/api/config.h
+++ b/include/odp/api/config.h
@@ -18,7 +18,7 @@
 extern "C" {
 #endif
 
-/** @addtogroup odp_compiler_optim
+/** @defgroup odp_config ODP CONFIG
  *  Macro for maximum number of resources in ODP.
  *  @{
  */
diff --git a/include/odp/api/cpumask.h b/include/odp/api/cpumask.h
index 02fd131..2ad7fea 100644
--- a/include/odp/api/cpumask.h
+++ b/include/odp/api/cpumask.h
@@ -20,7 +20,7 @@ extern "C" {
 
 #include <odp/config.h>
 
-/** @addtogroup odp_scheduler
+/** @defgroup odp_cpumask ODP CPUMASK
  *  CPU mask operations.
  *  @{
  */
diff --git a/include/odp/api/debug.h b/include/odp/api/debug.h
index 660569f..252a82f 100644
--- a/include/odp/api/debug.h
+++ b/include/odp/api/debug.h
@@ -17,18 +17,13 @@
 extern "C" {
 #endif
 
-/** @addtogroup odp_ver_abt_log_dbg
- *  Macros that allows different messages.
- *  @{
- */
-
 #if defined(__GNUC__) && !defined(__clang__)
 
 
 #if __GNUC__ < 4 || (__GNUC__ == 4 && (__GNUC_MINOR__ < 6))
 
 /**
- * _Static_assert was only added in GCC 4.6. Provide a weak replacement
+ * @internal _Static_assert was only added in GCC 4.6. Provide a weak replacement
  * for previous versions.
  */
 #define _Static_assert(e, s) (extern int (*static_assert_checker(void)) \
@@ -42,14 +37,11 @@ extern "C" {
 
 
 /**
- * Compile time assertion-macro - fail compilation if cond is false.
- * @note This macro has zero runtime overhead
+ * @internal Compile time assertion-macro - fail compilation if cond is false.
+ * This macro has zero runtime overhead
  */
 #define _ODP_STATIC_ASSERT(cond, msg)  _Static_assert(cond, msg)
 
-/**
- * @}
- */
 
 #ifdef __cplusplus
 }
diff --git a/include/odp/api/errno.h b/include/odp/api/errno.h
index 527214e..9829807 100644
--- a/include/odp/api/errno.h
+++ b/include/odp/api/errno.h
@@ -17,7 +17,7 @@
 extern "C" {
 #endif
 
-/** @addtogroup odp_ver_abt_log_dbg
+/** @defgroup odp_errno ODP ERRNO
  *  @{
  */
 
diff --git a/include/odp/api/pool.h b/include/odp/api/pool.h
index c679781..a813d33 100644
--- a/include/odp/api/pool.h
+++ b/include/odp/api/pool.h
@@ -22,7 +22,7 @@ extern "C" {
 
 #include <odp/std_types.h>
 
-/** @addtogroup odp_buffer
+/** @defgroup odp_pool ODP POOL
  *  Operations on a pool.
  *  @{
  */
diff --git a/include/odp/api/system_info.h b/include/odp/api/system_info.h
index 1f3294b..e55ff6d 100644
--- a/include/odp/api/system_info.h
+++ b/include/odp/api/system_info.h
@@ -19,7 +19,7 @@ extern "C" {
 #endif
 
 
-/** @addtogroup odp_ver_abt_log_dbg
+/** @defgroup odp_system ODP SYSTEM
  *  @{
  */
 
diff --git a/include/odp/api/time.h b/include/odp/api/time.h
index 836866d..b0072fc 100644
--- a/include/odp/api/time.h
+++ b/include/odp/api/time.h
@@ -19,7 +19,7 @@ extern "C" {
 #endif
 
 
-/** @defgroup odp_system ODP SYSTEM
+/** @defgroup odp_time ODP TIME
  *  @{
  */
 
diff --git a/include/odp/api/version.h b/include/odp/api/version.h
index 5d1abfa..93fbacf 100644
--- a/include/odp/api/version.h
+++ b/include/odp/api/version.h
@@ -18,7 +18,7 @@
 extern "C" {
 #endif
 
-/** @defgroup odp_ver_abt_log_dbg ODP LOGGING / ABORT / VERSION / DEBUG / ERRNO
+/** @defgroup odp_version ODP VERSION
  *  @{
  */
 
diff --git a/platform/linux-generic/include/odp/config.h b/platform/linux-generic/include/odp/config.h
index b0211b1..6fecd38 100644
--- a/platform/linux-generic/include/odp/config.h
+++ b/platform/linux-generic/include/odp/config.h
@@ -17,14 +17,6 @@
 extern "C" {
 #endif
 
-/** @ingroup odp_compiler_optim
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/config.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/cpumask.h b/platform/linux-generic/include/odp/cpumask.h
index f09bb91..cf7ad9d 100644
--- a/platform/linux-generic/include/odp/cpumask.h
+++ b/platform/linux-generic/include/odp/cpumask.h
@@ -23,14 +23,6 @@ extern "C" {
 #include <odp/std_types.h>
 #include <odp/plat/cpumask_types.h>
 
-/** @ingroup odp_scheduler
- *  @{
- */
-
-/**
- * @}
- */
-
 #include <odp/api/cpumask.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/errno.h b/platform/linux-generic/include/odp/errno.h
index 3e9e1fa..e53b49c 100644
--- a/platform/linux-generic/include/odp/errno.h
+++ b/platform/linux-generic/include/odp/errno.h
@@ -17,13 +17,7 @@
 extern "C" {
 #endif
 
-/** @addtogroup odp_ver_abt_log_dbg
- *  @{
- */
 
-/**
- * @}
- */
 #include <odp/api/errno.h>
 
 #ifdef __cplusplus
diff --git a/platform/linux-generic/include/odp/plat/buffer_types.h b/platform/linux-generic/include/odp/plat/buffer_types.h
index 0c017ae..3203020 100644
--- a/platform/linux-generic/include/odp/plat/buffer_types.h
+++ b/platform/linux-generic/include/odp/plat/buffer_types.h
@@ -20,11 +20,6 @@ extern "C" {
 #include <odp/std_types.h>
 #include <odp/plat/strong_types.h>
 
-/** @addtogroup odp_buffer ODP BUFFER
- *  Operations on a buffer.
- *  @{
- */
-
 /** ODP buffer */
 typedef ODP_HANDLE_T(odp_buffer_t);
 
@@ -43,10 +38,6 @@ static inline uint64_t odp_buffer_to_u64(odp_buffer_t hdl)
 	return _odp_pri(hdl);
 }
 
-/**
- * @}
- */
-
 #ifdef __cplusplus
 }
 #endif
diff --git a/platform/linux-generic/include/odp/plat/cpumask_types.h b/platform/linux-generic/include/odp/plat/cpumask_types.h
index df3c797..6fba832 100644
--- a/platform/linux-generic/include/odp/plat/cpumask_types.h
+++ b/platform/linux-generic/include/odp/plat/cpumask_types.h
@@ -18,7 +18,7 @@
 extern "C" {
 #endif
 
-/** @addtogroup odp_compiler_optim
+/** @addtogroup odp_cpumask
  *  @{
  */
 
diff --git a/platform/linux-generic/include/odp/system_info.h b/platform/linux-generic/include/odp/system_info.h
index 1e8811c..d692606 100644
--- a/platform/linux-generic/include/odp/system_info.h
+++ b/platform/linux-generic/include/odp/system_info.h
@@ -19,13 +19,6 @@ extern "C" {
 
 #include <odp/std_types.h>
 
-/** @ingroup odp_ver_abt_log_dbg
- *  @{
- */
-
-/**
- * @}
- */
 
 #include <odp/api/system_info.h>
 
diff --git a/platform/linux-generic/include/odp/time.h b/platform/linux-generic/include/odp/time.h
index 0620ebd..3a3960b 100644
--- a/platform/linux-generic/include/odp/time.h
+++ b/platform/linux-generic/include/odp/time.h
@@ -19,13 +19,7 @@ extern "C" {
 
 #include <odp/std_types.h>
 
-/** @ingroup odp_system
- *  @{
- */
 
-/**
- * @}
- */
 
 #include <odp/api/time.h>
 